#include <IRremote.h>

//Подключение IR приемника с именем irrecv
//Используется в модуле 

IRrecv irrecv(IR_PIN);

class IRButton {
  public:
   void tick();
   uint32_t NumisClick();   // возвращает true при вводе числа. Сбрасывается после вызова
   bool UpIsPress();        // возвращает true при нажатии на кнопку. 
   bool DownIsPress();      // возвращает true при нажатии на кнопку. 
   bool LeftIsPress();      // возвращает true при нажатии на кнопку. 
   bool RightIsPress();     // возвращает true при нажатии на кнопку. 

   bool OkClick();          // возвращает true при клике Ok. Сбрасывается после вызова
   bool StarClick();        // возвращает true при клике *. Сбрасывается после вызова
   bool DiezClick();        // возвращает true при клике #. Сбрасывается после вызова
   bool pressed;
   bool pressed_num;
   
  private:
   void clearBTN();
   uint32_t IR_delay;
   uint32_t NUM_delay;
   uint32_t IR_XX;  
   bool IR_XX_S=false;  
   bool IR_XX_byte=false;  
   decode_results results;
   bool pressed_ok;
   bool pressed_star;
   bool pressed_diez;

   bool pressed_up;
   bool pressed_down;
   bool pressed_left;
   bool pressed_right;
  //Коды клавиш
   uint32_t up=0xFF18E7;
   uint32_t down=0xFF4AB5;
   uint32_t left=0xFF10EF;
   uint32_t right=0xFF5AA5;
   uint32_t Ok=0xFF38C7;
   uint32_t star=0xFF6897;
   uint32_t diez=0xFFB04F;


   uint32_t repeat=0xFFFFFFFF;
   uint32_t IR_Digit[10]={0xFF9867,0xFFA25D,0xFF629D,0xFFE21D,0xFF22DD,0xFF02FD,0xFFC23D,0xFFE01F,0xFFA857,0xFF906F}; // 0..9
};


void IRButton::clearBTN(){
      pressed_up=false;
      pressed_down=false;
      pressed_left=false;
      pressed_right=false;

}

void IRButton::tick() {
  if (irrecv.decode(&results)) {

    if (results.value==Ok) {
       clearBTN();
       pressed_ok=true;
       pressed=true;
       }

    if (results.value==star) {
       clearBTN();
       pressed_star=true;
       pressed=true;
       }

    if (results.value==diez) {
       clearBTN();
       pressed_diez=true;
       pressed=true;
       }

//Up
    if (results.value==up) {
       clearBTN();
       pressed_up=true;
       pressed=true;
       IR_delay= millis();
    }
    if (results.value==down) {
       clearBTN();
       pressed_down=true;
       pressed=true;
       IR_delay= millis();
    }
    if (results.value==left) {
       clearBTN();
       pressed_left=true;
       pressed=true;
       IR_delay= millis();
    }
    if (results.value==right) {
       clearBTN();
       pressed_right=true;
       pressed=true;
       IR_delay= millis();
    }
  
    if (results.value==repeat) {
       pressed=true;
       IR_delay= millis();
    }
    // Ввод числа
    for (int i=0; i<10; i++) 
     if (results.value==IR_Digit[i]) 
     {
      if (millis() - NUM_delay > 1000) //Если число не вводилось более секунды назад
      {
        IR_XX=i;
        IR_XX_S=true;
        NUM_delay= millis();
      } else
      {
        if (IR_XX_S) IR_XX=IR_XX*10+i;
        NUM_delay= millis();
      } 
     } 

    irrecv.resume(); // Receive the next value
  }
    //Таймоут ввода числа
    if (millis() - NUM_delay > 1000 && IR_XX_S) //По истечении 1000ms считается окончание ввода числа
    { 
      IR_XX_S=false;
      pressed_num=true;
    }
    if (millis() - IR_delay > 1000) clearBTN();

     
  
}
  
uint32_t IRButton::NumisClick() {
  pressed=false;
  pressed_num=false;
#ifdef _DEBUG
  Serial.println(IR_XX);
#endif
  return IR_XX;
}
bool IRButton::OkClick() {
  if (pressed && pressed_ok)
    {
      pressed=false;
      pressed_ok=false;
      return true;
    }
  return false;
}
bool IRButton::StarClick() {
  if (pressed && pressed_star)
    {
      pressed=false;
      pressed_star=false;
      return true;
    }
  return false;
}
bool IRButton::DiezClick() {
  if (pressed && pressed_diez)
    {
      pressed=false;
      pressed_diez=false;
      return true;
    }
  return false;
}

bool IRButton::UpIsPress() {
  if (pressed && pressed_up)
    {
      pressed=false;
      return true;
    }
  return false;
}
bool IRButton::DownIsPress() {
  if (pressed && pressed_down)
    {
      pressed=false;
      return true;
    }
  return false;
}
bool IRButton::LeftIsPress() {
  if (pressed && pressed_left)
    {
      pressed=false;
      return true;
    }
  return false;
}
bool IRButton::RightIsPress() {
  if (pressed && pressed_right)
    {
      pressed=false;
      return true;
    }
  return false;
}
//Перевод времени с IR на time

IRButton IR_BTN;

void ir_setup()
{
 irrecv.enableIRIn(); // 
}

void ir_loop() {

  IR_BTN.tick(); //Опрос датчика Вставить в void loop() при использовании
  if (IR_BTN.pressed_num) {
      uint32_t IRBTN=IR_BTN.NumisClick();
      if (IRBTN==55) mp3_play_time=1; // Сказать время
      if (IRBTN>100 && IRBTN<=199){ 
          h_off=IRBTN-100;
          change_H=h_off;
          change_M=h_on;
          timer_change=millis();
          eeprom_write_byte(16,h_off);
        }
      if (IRBTN>200 && IRBTN<=299){
          h_on =IRBTN-200;
          change_H=h_off;
          change_M=h_on;
          eeprom_write_byte(17,h_on);
          timer_change=millis();
        }
      if (IRBTN<=max_mp3_forders) {
             num_folder[choice_bird_rain()]=IRBTN;
             // Записать соответствие папки
             eeprom_write_byte(choice_bird_rain(), IRBTN);
        }
      if (IRBTN>=300 && IRBTN<324){
            change_H =IRBTN-300;
            rtc.adjust(DateTime(2020, 1, 21, change_H, change_M, 0)); // установка нового времени в RTC
         }
      if (IRBTN>=400 && IRBTN<460){
            change_M =IRBTN-400;
            rtc.adjust(DateTime(2020, 1, 21, change_H, change_M, 0)); // установка нового времени в RTC
         }
      }

     if (IR_BTN.DiezClick()) { // При нажатии на # Показать настройки 
          change_H=h_off;
          change_M=h_on;
          timer_change=millis();
      }
     if (IR_BTN.StarClick()) { mp3_next(1); }        // При нажатии на * играть следующую случайную
     if (IR_BTN.OkClick()) {   // Включение / отключение Auto воспроизведения
      Playflag = !Playflag; 
         u8g.firstPage();
           do {
               u8g.setFont(u8g_font_osb29n);
               u8g.setPrintPos(60, 50);
               if (Playflag) u8g.print(1);
                       else  u8g.print(0);
           } while ( u8g.nextPage());
           delay(1000);
      } 
 }
//-------------Пример использования
 
/*  
  if (IR_BTN.OkClick()) Serial.println("Нажата Ok");
  if (IR_BTN.pressed_num) Serial.println("Набрали "+String(IR_BTN.NumisClick()));
  if (IR_BTN.UpIsPress()) Serial.println("Нажата Up");
  if (IR_BTN.DownIsPress()) Serial.println("Нажата Down");
  if (IR_BTN.LeftIsPress()) Serial.println("Нажата Left");
  if (IR_BTN.RightIsPress()) Serial.println("Нажата Righ");
   
  */
